*******************************
* FILE: DISKIO.ASM
*******************************

* CONTAINS DISK I/O ROUTINES AND
* ROM TO RAM ROUTINE. EXPECTS
* GRAPHICS SCREEN MOVED TO $8400


* ADJUST THE NEXT LINE FOR EACH ADVENTURE
* EXAMINE TAPE SAVE ROUTINE FOR VALUE
* AND COPY HERE BEFORE DELETING ALL
* TAPE RELATED CODE !!EXCEPT!!
* SAVHDR. LEAVE SAVHDR IN PLACE!

ROOMSZ EQU RMSIZE*NORMS

*******************************
* DISK I/O ROUTINES FOR ALL
* MARK DATA ADVENTURES
*  ADDED BY Robert Gault
* April 1, 2000
*******************************

READ EQU 2
WRITE EQU 3

*******************************
*
* DISK SAVE GAME ROUTINE
* STORES STARTING @ TRACK 0, SECTOR 1
*
*******************************

VSAVE EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #CASMSG ACTUALLY A DISK MESSAGE NOW
 JSR DISPLY
 LBSR GETNUM
 BEQ X@
 PSHS U
 LDB #15
 LDX #SAVHDR
 JSR $A59A MOVE DATA
 LDB #CURPOS
 LDX #ROOM
 JSR $A59A MOVE DATA
 PULS U
 LDA #WRITE OPCODE
 STA $EA DSKCON OPCODE
 JSR [$C004] WRITE SECTOR
 LDX #ROOMTB
 LDD #ROOMSZ
 TSTB REG.A = N*$100, REG.B = REMAINDER
 BEQ B@
 INCA MUST BE EVEN NUMBER OF SECTORS
B@ STX $EE SET NEW DSCKON BUFFER POINTER
 JSR SECTUP INCREMENT SECTOR& TRACK AS NEEDED
 JSR [$C004] WRITE SECTOR
 LDX $EE UPDATE DSCKON BUFFER
 LEAX $100,X UPDATE BUFFER POINTER
 DECA DECREASE SECTOR COUNT
 BNE B@
 LDA #READ LOCK OUT FIRST 6 GRANS FROM DISK BASIC
 STA $EA
 LDX #17*256+2 FAT TABLE
 STX $EC
 LDX #$700 PROTECT GRANS 0-3
 STX $EE
 JSR [$C004] READ FAT
 LDD #$9999
 STD ,X++ MARK NOT FREE
 STD ,X++
 STD ,X
 LDA #WRITE
 STA $EA
 JSR [$C004] WRITE MODIFIED FAT
 CLR $FF40 TURN OFF DRIVE
X@ JMP REPLY BACK TO MAIN GAME LOOP

***********************************
*
* GETNUM: GET NUMBER SUBR. FOR DISK
* RETURN TRACK & SECTOR FOR STORAGE
* VARIATION ON GETLIN
*
***********************************

GETNUM LDY #10
 CLR MSGLNS *SOME GAMES DON'T NEED THIS LINE
A@ JSR CURSOR
 INC RANDOM
 JSR [$A000] READ KEYBOARD
 BEQ A@
 CMPA #13 CR
 BEQ C@
B@ CMPA #'0 IS IT A #
 BLO A@
 CMPA #'9
 BHI A@
 JSR CHROUT ECHO THE # TO SCREEN
 SUBA #'0 CONVERT TO HEX$
 PSHS A
 LDD #ROOMSZ
 TSTB
 BEQ E@
 INCA
E@ INCA
 PULS B
 MUL
* CALCULATE TRACK SECTOR OFFSET FROM TOTAL SECTORS
D@ INCA DIVIDE SECTORS BY 18
 SUBB #18 MAXIMUM SECTOR VALUE
 BPL D@
 DECA COMPENSATE
 ADDB #19 BASE1 NOT BASE0
 STD $EC TRACK & SECTOR
 LDU #$700
 STU $EE DSCKON BUFFER POINTER
C@ RTS

*******************************
* INCREMENT SECTOR AND ALSO
* TRACK AS NEEDED
*******************************
SECTUP PSHS D
 LDD $EC GET TRACK&SECT
 INCB
 CMPB #18
 BLS A@
 INCA INCREASE TRACK
 LDB #1 INIT SECT
A@ STD $EC
 PULS D,PC

*******************************
*
* DISK LOAD GAME ROUTINE
* SEE SAVE FOR COMMENTS
*
*******************************

VLOAD EQU *
 LDD SCORE
 SUBD #1
 STD SCORE
 LDX #CASMSG
 JSR DISPLY
 LBSR GETNUM
 BEQ X@
 LDA #READ
 STA $EA DSCKON OPCODE
 JSR [$C004] READ HEADER
 TST $F0 DSCKON ERROR CODE
 BNE D@ IF ERROR
 LDY #SAVHDR IS THIS A SAVED TREKBOER GAME?
 LDX #$700
 LDB #15
G@ LDA ,X+
 CMPA ,Y+
 BNE E@
 DECB
 BNE G@
 PSHS U
 LDB #CURPOS RETRIEVE DATA
 LDU #ROOM
 JSR $A59A MOVE DATA
 PULS U
 LDX #ROOMTB
 LDD #ROOMSZ
 TSTB
 BEQ B@
 INCA
B@ STX $EE SET DSCKON BUFFER POINTER
 JSR SECTUP
 JSR [$C004] READ DISK
 TST $F0
 BNE D@ IF ERROR
 LDX $EE
 LEAX $100,X
 DECA
 BNE B@
C@ CLR $FF40 STOP DRIVE
 CLR NOUNNO
 JMP VLOOK
D@ LDX #IOERR
 BRA F@
E@ LDX #BADTAP
F@ CLR $FF40 STOP DRIVE
 JSR DISPLY
X@ JMP REPLY

CASMSG FCB 13
 FCC 'Insert disk in driv','e+$80
 FCB C.AND
 FCC 'enter the game# (0-9), <ENTER>=Abort',')+$80
 FCB 0

BADTAP FCB 13
 FCC 'Invalid game save disk.',0

IOERR FCB 13
 FCC 'Disk I/O error.',0

***************************
* ROMRAM THIS ROUTINE
* TRANSFERS THE ROM DATA
* FROM $8000-$DFFF TO RAM
* AND EXITS IN RAM MODE
***************************

ROMRAM ORCC #$50
 LDX #$8000
A@ STA $FFDE
 LDD ,X
 STA $FFDF
 STD ,X++
 CMPX #$E000
 BNE A@
 RTS

* END FILE: DISKIO.ASM
